#include <math.h>
#include <stdlib.h>
#include <iostream>
#include <iomanip>
#include <string>
#include <list>
#include <queue>


#define KOMMENTAR '#'
#define BLANK ' '
#define NL '\n'
#define TAB '\t'

int main(int argc, char * argv[]) 
{
  string d;
  double samplerate;
  int FRAMESIZE = 1024;
  double NOISE = 0.02;


  
  if (argc <= 2)
    {
      cerr << "usage: energy FRAMESIZE NOISE" << NL
	   << "  FRAMESIZE: number of samples considered" << NL
	   << "  NOISE: maximum energy/sample for noise" << NL;
      return 1;
    }
  FRAMESIZE = atoi(argv[1]);
  NOISE = atof(argv[2]);
  
  //read SOX header
  cin >> d;  cout <<  d << BLANK;
  cin >> d;  cout <<  d << BLANK; 
  cin >> d;  cout <<  d << BLANK; 
  cin >> samplerate;  cout <<  samplerate << NL;
      
  
  queue< double, list < double > > qin, qtime, qamp, qenergy;
  
  double time, amp;
  double energy = 0;
  
  while(qamp.size() < (unsigned int) FRAMESIZE && !cin.fail() && !cin.eof())
    {
      cin  >> time >> amp;
      qtime.push(time), qamp.push(amp), qin.push(amp);
      energy += fabs(amp);
      qenergy.push(energy);
    }
  
  
  while(!cin.fail() && !cin.eof())
    {
      cin  >> time >> amp;
      qin.push(amp);
      qtime.push(time);
      qamp.push(amp);
      energy -= fabs(qin.front()), qin.pop();
      energy += fabs(amp);
      qenergy.push(energy);
      //cerr << time << ": " << energy << NL;
    }
  //  cerr << "Energy: " << qenergy.size() << NL
  //   << "Amps: " << qamp.size() << NL
  //   << "Time: " << qtime.size() <<NL;
  // no valid values for energy within the first frame
  
  for (int i = 0; i < FRAMESIZE; i++)
    qenergy.pop();

  
  double THRESHOLD = FRAMESIZE * NOISE;
  
  //did we start with noise?
  while(!qenergy.empty())
    {
      energy = qenergy.front(); 
      if(energy <= THRESHOLD)             // was the last frame noise?
	for(int i = 0; i < FRAMESIZE && !qenergy.empty(); i++)       
	  // output 0 for all of frame
	  {                                          // and advance to next 
	    cout << qtime.front() << TAB << '0' << NL;
	    qtime.pop();
	    qamp.pop();
	    qenergy.pop();
	  }
      else
	{
	  cout << qtime.front() << TAB << qamp.front() << NL;
	  qtime.pop();
	  qamp.pop();
	  qenergy.pop();
	}
    }

  if(energy <= THRESHOLD)  
    while(!qamp.empty())
      cout << qtime.front() << TAB  
	   << '0' << NL, 
	qtime.pop(), 
	qamp.pop(); 
  else
    while(!qamp.empty())
      cout << qtime.front() << TAB 
	   << qamp.front() << NL, 
	qtime.pop(), 
	qamp.pop();
  
  return 0;
}












