/* 
 * smooth.cpp
 * 
 * smooth the spectrum of a fouriertransformed data 
 * usage: cat data.spec | smooth > data.smooth
 *
 */

/* change: INTERsmooth ;)
 */

#include <stdlib.h>
#include <iostream>
#include <iomanip>
#include <string>
#include <list>
#include <queue>
#include <vector>

#define KOMMENTAR '#'
#define BLANK ' '
#define NL '\n'
#define TAB '\t'

#define READ_COMMENT(number_of_arguments)                                      {       int counter;                                                                   for(counter = 0; counter < number_of_arguments; counter ++)                      cin >> kommentar;                                                    }

#define COPY_COMMENT(number_of_arguments)                                      {       int counter;                                                                   for(counter = 0; counter < number_of_arguments; counter++)                       {                                                                                 cin >> kommentar;                                                              if(!cin.eof() && !cin.fail())                                                     cout << kommentar << BLANK;                                              }                                                                    }
 
#define COPY_COMMENT_LINE(number_of_arguments)                                         COPY_COMMENT(number_of_arguments)                                              cout << NL

#define PUSH push_back
#define POP pop_front
           
int main( int argc, char *argv[] ) {
  
  int  area = 7;
  int framesize;
  string kommentar;
  // double smoothfactor[7] = {0.1, 0.4, 0.9, 1, 0.9, 0.4, 0.1};
  // double totalsmooth = 3.8;
  double amplitude, frame, freq, phase;

  /**************************************  
   *                                    *
   *  Processing of Data File Header:   *
   *                                    *
   **************************************/

  READ_COMMENT(2);                                  // Title line
  READ_COMMENT(4);                                  // Sample Rate
  READ_COMMENT(3);
  cin >> framesize;                                 // Framesize
  READ_COMMENT(4);
  READ_COMMENT(8);                                  // Frameshift

  //write Header:
  cout << KOMMENTAR << " many vectors of dimension " << framesize/2 << NL; 
  cout << NL;  


  READ_COMMENT(8);           // Frame number & offset

  /**************************
   *                        *
   * Processing of Data:    *
   *                        *
   **************************/
  queue< double, list < double > > qamp[area];  
  queue< double, list < double > > qsmooth;
  int vectornumber = 0;

  while(!cin.eof() && !cin.fail()) 
    {
      for(int counter = 0; counter < framesize/2; counter ++)
	{
	  cin >> frame >> freq >> amplitude >> phase;
	  qamp[vectornumber%area].push(amplitude);
	}
      
      // cerr << "Reading Vector " << vectornumber%area << NL;
      
      if (vectornumber < area/2)
	{
	}
      else if (area/2 <= vectornumber &&  vectornumber < area-1) 
	{
	  for(unsigned int i = qamp[vectornumber-area/2].size(); i > 0; i--)
	  {    
	    if(i > qamp[vectornumber-area/2].size()-10)
	      {
		qsmooth.push(0);
		qamp[vectornumber-area/2].push(0);
		qamp[vectornumber-area/2].pop();
	      }
	    else
	      {
		qsmooth.push(qamp[vectornumber-area/2].front());
		qamp[vectornumber-area/2].
		  push(qamp[vectornumber-area/2].front());
		qamp[vectornumber-area/2].pop();
	      }
	  }
	} 
      else
	{
	  for(int j = 0; j < framesize/2; j++)
	    {
	      double sum =0;
	      for (int i = vectornumber-area/2; 
		   i <= vectornumber + area/2; i++)
		{
		  //sum += smoothfactor[i%area] * qamp[i%area].front();
		  sum += qamp[i%area].front();
		  qamp[i%area].push(qamp[i%area].front()), qamp[i%area].pop();
		}
	      sum /= area;
	      if (j < 10) 
		qsmooth.push(0);
	      else qsmooth.push(sum);
	      
	    }
	  while(!qamp[(vectornumber+1)%area].empty())
	    qamp[(vectornumber +1)%area].pop();
	  // cerr << "Killing Vector " << (vectornumber+1)%area << NL;
	}

      READ_COMMENT(8);
      
      //output
      if (!qsmooth.empty())
	cout << KOMMENTAR << " Vector number " << vectornumber - area/2<< NL;
      while(!qsmooth.empty())
	cout << qsmooth.front() << NL, qsmooth.pop();

      
      vectornumber++;
    }
  
  for (int i = vectornumber - area/2;  i < vectornumber; i++)
    {
      cout << KOMMENTAR << " Vector number " << i << NL;
      while(!qamp[i%area].empty())
	cout << qamp[i%area].front() << NL, qamp[i%area].pop(); 
      cout << NL;
    }
  return 0; 
}

 












