#include <stdlib.h>
#include <iostream>
#include <iomanip>
#include <string>
#include <list>
#include <queue>

#define KOMMENTAR '#'
#define BLANK ' '
#define NL '\n'
#define TAB '\t'

int main( int argc, char *argv[] ) {

  double cutoff = 0;
  double maximum = 0;
  double zeit = 0;
  double amplitude;
  string kommentar;
  queue< double, list<double> > zeiten_q;
  queue< double, list<double> > amplituden_q; 

  if(argc > 1) cutoff = atof(argv[1]);           // wie viel schneiden wir
                                                 // am Anfang ab? typecheck?!  
                                                 
  cin >> kommentar, cout << KOMMENTAR << BLANK;  // Den Header einlesen
  cin >> kommentar, cout << kommentar << BLANK;  // "Sampling"
  cin >> kommentar, cout << kommentar << BLANK;  // "Rate"
  cin >> kommentar, cout << kommentar << NL;     // Samplingrate

  while(!cin.eof() &&                            // den Anfang des Files bis
	!cin.fail() &&                           // zum CUTOFF wegschneiden
	zeit < cutoff)                           // weil da immer ein Knacksen
    cin >> zeit, cin >> amplitude;               // vom Mikro drin ist

  while(!cin.eof() && !cin.fail()) {
    cin >> zeit;                                 // zuerst immer die Zeit
    cin >> amplitude;                            // dann die Amplitud der Welle
    if(fabs(amplitude) > maximum)                // wir suchen das Maximum
      maximum = fabs(amplitude);                 // im Signal und schieben die
    zeiten_q.push(zeit-cutoff);                  // Daten solange in zwei
    amplituden_q.push(amplitude);                // Schlangen
  }

  while(!zeiten_q.empty() &&                     // Jetzt machen wir die beiden
	!amplituden_q.empty()) {                 // Schlangen wieder leer
    cout << zeiten_q.front() << TAB              // schreiben die Zeit einfach
	 << amplituden_q.front()/maximum << NL;  // so und die Amplituden
    zeiten_q.pop();                              // normalisiert wieder raus
    amplituden_q.pop();
  }

  return 0;
   
}
