#! /usr/bin/perl -w

# usewav.pl 

if($#ARGV < 1) {
   print "\nuse.pl CODEBOOKFILE WAVFILE\n\n";
} else { 

  $VQFILE   =  $ARGV[0];
  $DATAFILE   =  $ARGV[1];

  if(-e $DATAFILE) {
  if(-e $VQFILE) { 

    # input file erzeugen falls noch nicht vorhanden
    if(!(-e "$DATAFILE.input")) {
      system "./wav2input $DATAFILE"
    }

    # norm file zur visualisierung erzeugen
    if(!(-e "$DATAFILE.norm")) {
      system "./wav2norm $DATAFILE"
    }

    # input in netz rein
    print "using $VQFILE ...\n"; 
    system "cat $DATAFILE.input | ./vq $VQFILE > $VQFILE.res";
  
    # gnuplot script erzeugen
    $N  = 10;   # Maximale Anzahl an Codebookvektoren 
    $FS = 1024; # Frame Size
    $TFS = 80;  # Time Frame Shift
    $SR = 8000; # Samplingrate
    open PLOT, ">./plot000";
    select PLOT;
    print "#! /usr/bin/gnuplot \n";
    print "\n set grid";
    print "\n set xlabel \"Zeit in Sekunden\"";
    print "\n set ylabel \"Codebookvektor Nr.\"";
    print "\n plot [] [-5:$N+1]";
    print "\"$DATAFILE.norm\" using 1:(\$2-3) title \"\" with lines, ";
    print "\"$VQFILE.res\" using ((\$1*$TFS+$FS/2)/$SR):2 title \"\"";
    print "\n pause -1 \"any key\"\n";
    close PLOT;

    # and execute it
    chmod 0777, "./plot000";
    system "./plot000";
    system "rm ./plot000";
  
  } else { print "$VQFILE does not exist\n"; }
  } else { print "$DATAFILE does not exist\n"; }
  

}

